# 
# If "?????????" then File - Reopen with Encoding... windows-1251
#
#   .. ,  
#     
#     "    "
# http://landscapeedu.ru/edu_help4_DT_and_R.shtml
#  .. 
# 
#  2.    (- ). 
# :        : 
# 
# 
#  2.1    
#  2.2   (, ,  )
#  2.3   
#  2.4    
#
# ######################################################################
#   13.03.2020
# ######################################################################

#  
library(aqp)         # ,      ()
library(soiltexture) #      
library(reshape)     #   
library(lattice)     #  
library(ggplot2)     #   
library(ithir)       #   Soil Security Laboratory (Australia)

install.packages("devtools", dep=TRUE) 
library(devtools)
install_bitbucket("brendo1001/ithir/pkg") 
#install.packages("ithir", repos="http://R-Forge.R-project.org", dep=TRUE)

# ######################################################################
# 2.1.    
# ######################################################################
#     (, , 1966, https://1drv.ms/b/s!AqgRGg8chAsVuXWb00g_idTMnXlb)
pedons = data.frame(sid=c("","","","","","", "","","","","", "","","","","", "","","","","", "","","","","",""), 
                     hz=c("0","A1","A1","AB","B","BC", "0","A1","A1B","B","BC", "A1","AB","B","B","BC", "0","A1","A1B","Bg1","Bg2", "0","A1","A12","A2Bg","Bg1","Bg2"), 
                    top=c(0,6,40,90,110,200,  0,6,80,100,200,  0,80,110,150,200,  0,10,95,125,165,  0,5,45,70,100,140),
                    bot=c(6,40,90,110,200,250, 6,80,100,200,250, 80,110,150,200,250, 10,95,125,165,250, 5,45,70,100,140,250),
                    hue=c("10YR","10YR","10YR","7.5YR","7.5YR","7.5YR", "10YR","10YR","7.5YR","7.5YR","7.5YR", "10YR","7.5YR","7.5YR","7.5YR","7.5YR", "10YR","10YR","7.5YR","7.5YR","7.5YR", "10YR","10YR","10YR","7.5YR","7.5YR","7.5YR"),
                  value=c(2,2,3,3,4,4, 2,2,3,4,4, 2,3,4,4,4, 2,2,4,4,4, 2,2,6,4,4,4),
                 chroma=c(2,1,1,3,3,3, 1,1,3,3,3, 1,3,3,3,3, 1,1,3,3,3, 1,1,3,3,3,3))
head(pedons[1:6,])    #   6  

#  hex-      AQP,  http://aqp.r-forge.r-project.org/aqp-html-manual/munsell2rgb.html
pedons$hex <- munsell2rgb(pedons$hue, pedons$value, pedons$chroma)

#   SoilProfileCollection (AQP)
depths(pedons) <- sid ~ top + bot

#    
par(mar=c(1,2.5,2,2)) #      , 
plotSPC(pedons, name='hz', cex.names=1, axis.line.offset=-2, color='hex', relative.pos=c(4,5,3,2,1)) 
lines(1:length(pedons), c(40,100,150,260,400), lty=1, lwd=2, col='red')
axis(2, line=0, at=pretty(1:max(pedons)), cex.axis=1, font=1, las=1, col='black', col.axis='black', lwd=1)
mtext('   (, , 1966)', side=3, line=1, font=1, col='black', cex=1.2)

#      (, , 1966)
MET_gran <- read.csv2("MET_gran.csv", header = TRUE, sep = ";", dec = ".", encoding="UTF-8", stringsAsFactors = FALSE) #   "\t"
head(MET_gran[1:6,])    #   6  
TT.plot(tri.data = MET_gran, class.sys = "USDA.TT", col = "red", cex=2, tri.sum.tst=FALSE, main = "   ")

# ######################################################################
# 2.2   (, ,  )
# ######################################################################

setwd("C:/Users/Danilko/OneDrive/0_EDU/R/METsid") #   
data <- read.csv2("MET_points_2020.txt", header = TRUE, sep = ";", dec = ".", fill = TRUE, 
                  comment.char = "", stringsAsFactors = FALSE) #   "\t"
head(data[1:5,1:15])    #   5   15  

# ######################################################################
# 2.2.1    
# ######################################################################

MET_hum = (data[c(1,8, 11:16)])
names(MET_hum) = c("id","sid","10","20","40","60","80","100")
head(MET_hum)          #   6  
MET_hum = melt(MET_hum, id=c("id","sid"), na.rm=TRUE) #   'reshape'
MET_hum = MET_hum[order(MET_hum$id,MET_hum$variable),]  #        ?!
head(MET_hum[1:6,])    #   6  
MET_hum$top = as.numeric(levels(MET_hum$variable))-10
MET_hum$bot = MET_hum$top + 10
head(MET_hum[1:6,])    #   6  

#       (Lattice)
MET_hum$variable = ordered(MET_hum$variable, levels=c("100","80","60","40","20","10"))
summary(MET_hum$value) #  ,       (Xlim)
xyplot(variable~value|id, data=MET_hum, type = "b", layout=c(15,7), xlim=c(0,12.5), xlab=" , %", ylab=", ",)

# ######################################################################
# 2.2.2    
# ######################################################################

MET_bd = (data[c(1,8, 17:22)])
names(MET_bd) = c("id","sid","10","20","40","60","80","100")
head(MET_bd)          #   6  
MET_bd = melt(MET_bd, id=c("id","sid"), na.rm=TRUE) #   'reshape'
MET_bd = MET_bd[order(MET_bd$id,MET_bd$variable),]
head(MET_bd[1:6,])    #   6  
MET_bd$top = as.numeric(levels(MET_bd$variable)) - 10
MET_bd$bot = MET_bd$top + 10
head(MET_bd[1:6,])    #   6  

#       (Lattice)
MET_bd$variable = ordered(MET_bd$variable, levels=c("100","80","60","40","20","10"))
summary(MET_bd$value) #  ,       (Xlim)
xyplot(variable~value|id, data=MET_bd, type = "b", layout=c(15,7), xlim=c(0.7,1.4), xlab=", /3, %", ylab=", ",)
#xyplot(variable~value|id, data=MET_bd, type = c("b", "smooth"), xlim=c(0.7,1.4), xlab=", /3, %", ylab=", ",)

# ######################################################################
# 2.2.3     
# ######################################################################

#        MET_hum  MET_bd 
MET_SOC = data.frame(MET_hum[,1:4], MET_bd[,4:6])
head(MET_SOC[1:6,])    #   6  
names(MET_SOC) = c("id","sid","LYR","hum","bd","top","bot")

#  3.1.  https://soilmapper.org/soil-variables-chapter.html#soil-properties-of-interest-for-global-soil-mapping
#     SOC_stock_2019.png
MET_SOC$soc=(MET_SOC$hum/100)*(10/100)*(MET_SOC$bd*100*100*100/1000)*1     # /2
head(MET_SOC[1:6,])    #   6  

#      (Lattice)
MET_SOC$LYR = ordered(MET_SOC$LYR, levels=c("100","80","60","40","20","10"))
summary(MET_SOC$soc) #  ,       (Xlim)
xyplot(LYR~soc|id, data=MET_SOC, type = "b", layout=c(15,7), xlim=c(0.2,11), xlab="  (/2)     10 ", ylab=", ",)

# ######################################################################
# 2.2.4     (AQP)
# ######################################################################

MET_SOC$sid <- ordered(MET_SOC$sid, levels=c("","","","","")) #   
depths(MET_SOC) <- id ~ top + bot #  
site(MET_SOC) <- ~ sid            #   ( (sid), ... , ,    .)
           
par(mar=c(1,2.5,0,1)) #      , 
plotSPC(MET_SOC[1:10,], name = 'hum', cex.names=0.8, axis.line.offset=-1, color = 'hum', col.palette = rev(palette(grey(c(0,0.95))))) 
plotSPC(MET_SOC[1:10,], name = 'bd' , cex.names=0.8, axis.line.offset=-1, color = 'hum', col.palette = rev(palette(grey(c(0,0.95))))) 
plotSPC(MET_SOC[1:10,], name = 'soc', cex.names=0.8, axis.line.offset=-1, color = 'soc', col.palette = rev(palette(grey(c(0,0.95))))) 

# ######################################################################
# 2.2.5.        
# ######################################################################

library(ithir) #   Soil Security Laboratory (Australia)

data(oneProfile) #   
oneProfile
par(mar=c(1,2,1,1)) #      , 
plot_soilProfile(oneProfile, vals = oneProfile$C.kg.m3., depths = oneProfile[,2:3], label= names(oneProfile))
#     1 
eaFit = ea_spline(oneProfile, var.name = "C.kg.m3.", d = t(c(0,5,15,30,60,100,200)), lam = 0.1, vlow = 0, show.progress = FALSE)
eaFit
#       
plot_ea_spline(splineOuts = eaFit, d = t(c(0,5,15,30,60,100,200)), maxd = 200, type = 3, plot.which = 1, label = "C.kg.m3")

#        (      (SPC))
plot_soilProfile(MET_SOC[MET_SOC$id=="k14-06",], vals = MET_SOC$soc, depths = MET_SOC[,6:7], label= names(MET_SOC))

#     (SPC) MET_SOC
eaFit = ea_spline(MET_SOC, var.name = "soc", d = t(c(0,10,20,30,40,50,60,70,80,90,100)), lam = 0.1, vlow = 0, show.progress = FALSE)

#    --   :(
plot_ea_spline(eaFit, d = t(c(0,10,20,30,40,50,60,70,80,90,100)), maxd = 100, type = 3, label = "soc", plot.which = 1)

#   soc   10 : rowSums(eaFit$harmonised[,2:11])
MET_sid_SOC = data.frame(MET_SOC@site$id, MET_SOC@site$sid, eaFit$harmonised[,2:11], rowSums(eaFit$harmonised[,2:11])) #, colSums(eaFit$var.1cm))
names(MET_sid_SOC)=c("id","sid","H010","H020","H030","H040","H050","H060","H070","H080","H090","H100","H01m")
head(MET_sid_SOC[1:5,])    #   5 

# ######################################################################
# 2.2.6.          
# ######################################################################
par(mar=c(5,2,1,1)) #      , 
boxplot(MET_sid_SOC$H01m, horizontal = TRUE, xlab = "     , /2")
boxplot(MET_sid_SOC$H100, MET_sid_SOC$H090, MET_sid_SOC$H080, MET_sid_SOC$H070, MET_sid_SOC$H060, MET_sid_SOC$H050, 
        MET_sid_SOC$H040, MET_sid_SOC$H030, MET_sid_SOC$H020, MET_sid_SOC$H010,
        horizontal = TRUE, col ='lightgray', xlab = "     , /2")

#MET_sid_SOC$sid <- ordered(MET_sid_SOC$sid, levels=c("","","","","")) #     
boxplot(MET_sid_SOC$H01m ~ MET_sid_SOC$sid) 
table(MET_sid_SOC$sid)   #     
#       10 (30)  

#   ()
library(car)  #  ,    recode()
MET_sid_SOC$sid = Recode(MET_sid_SOC$sid, "''='';''='';''=''; ''=''; ''=''")
MET_sid_SOC$sid = ordered(MET_sid_SOC$sid, levels=c("","","","")) #     
table(MET_sid_SOC$sid)   #     

library(ggplot2)
library(ggridges)

ggplot(MET_sid_SOC, aes(x = H01m, y = sid, fill = sid)) +
        geom_density_ridges() +
        theme_ridges() + 
        theme(legend.position = "none")

MET_SOC@site$sid = Recode(MET_SOC@site$sid, "''='';''='';''=''; ''=''; ''=''")
MET_SOC@site$sid = ordered(MET_SOC@site$sid, levels=c("","","","")) #     
table(MET_sid_SOC$sid)   #     

#     
agg = slab(MET_SOC, fm =  sid ~ soc)

#     sid- (, 25%  75%    ), lattice
par(mar=c(1,2,0,0)) #      , 

xyplot(top ~ p.q50 | sid, data=agg, groups = sid, ylab=', ', xlab=',  25%  75% ',
       lower=agg$p.q25, upper=agg$p.q75, ylim=c(100,0), xlim=c(0.2,11),
       panel=panel.depth_function, alpha=0.25, sync.colors=FALSE,
       par.settings=list(superpose.line=list(lwd=2, col=c('orange','black', 'green', 'blue'))),
       prepanel=prepanel.depth_function,
       layout=c(4,1), strip=strip.custom(bg=grey(1)),
       scales=list(x=list(tick.number=4, alternating=2, relation='free')),
       #auto.key=list(columns=5, lines=TRUE, points=FALSE) # 
)

xyplot(top ~ p.q50 | sid, data=agg, groups = sid, ylab=', ', xlab=',  25%  75% ',
       lower=agg$p.q25, upper=agg$p.q75, ylim=c(100,0), xlim=c(0.2,11),
       panel=panel.depth_function, alpha=0.25, sync.colors=TRUE,
       par.settings=list(superpose.line=list(lwd=2, col=c('orange','black', 'green', 'blue'))),
       prepanel=prepanel.depth_function,
       #cf=agg$contributing_fraction, cf.col='black', cf.interval=5, 
       layout=c(1,1), strip=strip.custom(bg=grey(1)),
       scales=list(x=list(tick.number=5, alternating=3, relation='free')),
       #auto.key=TRUE
)

# ######################################################################
# MET_sid_SOC  sid
MET_sid_SOC = data.frame(MET_SOC@site$id, eaFit$harmonised[,2:11], rowSums(eaFit$harmonised[,2:11])) #, colSums(eaFit$var.1cm))
names(MET_sid_SOC)=c("id","H010","H020","H030","H040","H050","H060","H070","H080","H090","H100","H01m")
head(MET_sid_SOC)    #   6 

Mcorr <- cor(MET_sid_SOC[,2:12]) #   
Mcorr
library(ellipse)
plotcorr(Mcorr, type="lower", mar=c(0,0,0,0))

#    ()
PCA.mod = princomp(MET_sid_SOC[,2:11], cor = FALSE)#, scale = FALSE) #      
summary(PCA.mod)     #  
loadings(PCA.mod)    #       (  ->1) 
biplot(PCA.mod, choices = 1:2, col=c('black','red'))    #      (    )

#   SOC  (   ) 
SOCin = data.frame(t(MET_sid_SOC[,2:11]), stringsAsFactors = FALSE)
SOCin[[1]]    #    
#     SOC ( id).  -  MET_sid_SOC[,2:11]

regSOC = lm(SOCin[[1]] ~ c(10,20,30,40,50,60,70,80,90,100))
SOCfit    = data.frame(id = MET_sid_SOC$id[[1]], t(regSOC$fitted.values))
head(SOCfit)    #   6 
goof(observed = SOCin[[1]], predicted = regSOC$fitted.values) #, plot.it = TRUE) #  library(ithir)

SOCpar    = data.frame(id = MET_sid_SOC$id[[1]], t(regSOC$coefficients), goof(observed = SOCin[[1]], predicted = regSOC$fitted.values), stringsAsFactors = FALSE) 
head(SOCpar)    #   6 

for(i in (2:ncol(SOCin)))  {
        regSOC = lm(SOCin[[i]] ~ c(10,20,30,40,50,60,70,80,90,100))
        SOCfit = rbind(SOCfit, data.frame(id = MET_sid_SOC$id[[i]], t(regSOC$fitted.values)))  
        SOCpar = rbind(SOCpar, data.frame(id = MET_sid_SOC$id[[i]], t(regSOC$coefficients), goof(observed = SOCin[[i]], predicted = regSOC$fitted.values)))
}
names(SOCpar) = c("id","intercept","b","R2","conc","MSE","RMSE","bias")
head(SOCpar)    #   6 
plot(SOCpar$intercept, SOCpar$b)

#   SOC   
# ####################################################

names(SOCfit) = c("id","H010f","H020f","H030f","H040f","H050f","H060f","H070f","H080f","H090f","H100f")
names(SOCfit) = c("id","10","20","30","40","50","60","70","80","90","100")
head(SOCfit)    #   6 

SOCfit = melt(SOCfit, id=c("id"), na.rm=TRUE) #   'reshape
SOCin  = melt(MET_sid_SOC[,1:11], id=c("id"), na.rm=TRUE) #   'reshape
SOCfit = data.frame(SOCfit, SOCin[[3]])
names(SOCfit) = c("id","Hz","SOCfit","SOCin")
head(SOCfit)    #   6 
SOCfit = SOCfit[order(SOCfit$id,SOCfit$Hz),] #        ?!
SOCfit$top = as.numeric(levels(SOCfit$Hz)) - 10
SOCfit$bot = SOCfit$top + 10
head(SOCfit)    #   6  

#       (Lattice)
SOCfit$Hz = ordered(SOCfit$Hz, levels=c("100","90","80","70","60","50","40","30","20","10"))
summary(SOCfit$SOCin) #  ,       (Xlim)
xyplot(Hz ~ SOCfit + SOCin | id, data=SOCfit, 
       type = c("l","l"), col=c('red','black'), layout=c(15,7), xlim=c(0,11), xlab="    10 , /2", ylab=", ",)

#   SOC       
# ####################################################

#     
dataP <- read.csv2("MET_points_2020plus.txt", header = TRUE, sep = ";", dec = ".", fill = TRUE, 
                  comment.char = "", stringsAsFactors = FALSE) #   "\t"
head(dataP[1:5,1:15])    #   5   15  
head(SOCpar)    #   6  

#   
SOCpar = merge(SOCpar, dataP[c("id","HCl","ksg","TPI20","cdep","TWI","met01")], by.x = "id", by.y = "id")
SOCpar = merge(SOCpar, MET_sid_SOC[,1:12], by.x = "id", by.y = "id")
head(SOCpar)    #   6  

#  
Mcorr <- cor(SOCpar[,2:ncol(SOCpar)])
Mcorr
library(ellipse)
plotcorr(Mcorr, type="lower", mar=c(0,0,0,0))

attach(SOCpar)
#  
plot(intercept, b)
plot(intercept, H01m)
plot(H01m, b)
plot(HCl, H01m)
plot(HCl, b)
plot(ksg, b)
plot(ksg, H01m)

#   ( )
regSOCfit = lm(b ~ met01 + TPI20 + cdep + TWI)
goof(observed = b, predicted = regSOCfit$fitted.values) #, plot.it = TRUE) #  library(ithir)
detach(SOCpar)

# ######################################################################
# 2.3  
# ######################################################################
#    (0)       (p-value)
#      (.   )
#    0.95,  p-value < 0.05,    H0   1

# H0:           

#          0  
x <- rnorm(1000, 0) #      
hist(x, breaks=11, freq = FALSE, main="", col = "lightblue", labels = FALSE)
lines(density(x, adjust=1), col = "red", lwd=3)
rug(x)
qqnorm(x, main = "", xlab = " ",
       ylab = " ", plot.it = TRUE, datax = FALSE)
qqline(x, datax = FALSE, distribution = qnorm, probs = c(0.25, 0.75),
       qtype = 7, col="red")
shapiro.test(x)        # 0:     (-) 
ks.test(x, "pnorm")    # 0:     (-)
shapiro.test(rnorm(100, mean = 5, sd = 3))

h001m. <- data$h001m[data$sid == ""] #   
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

h001m. <- data$h001m[data$sid == ""] #   
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

h001m. <- data$h001m[data$sid == ""] #    
shapiro.test(h001m.)        # 0:     (-) 
ks.test(h001m., "pnorm")    # 0:     (-)

# 0:      ( )
t.test(h001m., mu=mean(h001m.)) 
t.test(h001m., mu=mean(h001m.))
t.test(h001m., mu=mean(h001m.))

#     
#     ,  -   (   )
t.test(h001m., h001m., conf.level = 0.95, paired=FALSE) #     :

pairwise.t.test(data$h001m, data$sid, p.adj="bonferroni") #    p-value      

#   -   ( ):
wilcox.test(h001m., h001m., paired=TRUE) #    
kruskal.test(list(h001m., h001m.))       #    
kruskal.test(list(h001m., h001m.))       #    

#:    0.95          (~  2 /)

##########################################################################
#       
##########################################################################

#         
dataN <- data.frame(var1=rnorm(200),
                    var2=rnorm(200))
dataN
str(dataN)

par(mar=c(2, 2, 1.5, 0.2)) #      
hist(dataN$var1, breaks=10, main="")
hist(dataN$var2, breaks=10, main="")
hist(dataN$var1, breaks=10, main="", col="lightblue")
hist(dataN$var2, breaks=10, main="", col="lightgreen", add=TRUE)

#   
qqnorm(dataN$var1, main = "Normal Q-Q Plot", xlab = "Theoretical Quantiles",
       ylab = "Sample Quantiles", plot.it = TRUE, datax = FALSE)
qqline(dataN$var1, datax = FALSE, distribution = qnorm, probs = c(0.25, 0.75),
       qtype = 7, col="red")
#       ,      .

t.test(dataN$var1, mu=mean(dataN$var1)) # 0:      ( )
t.test(dataN$var2, mu=mean(dataN$var1)) # 0:      ( )
shapiro.test(dataN$var1) # 0:    
shapiro.test(dataN$var2) # 0:    

dataN$var3 <- dataN$var2 + 0.5
boxplot(dataN$var1, dataN$var2)
boxplot(dataN$var1, dataN$var3)

#     ( )   :
t.test(dataN$var1, dataN$var2, conf.level = 0.95, paired=FALSE)
t.test(dataN$var1, dataN$var3, conf.level = 0.95, paired=FALSE)

#     ( ):
wilcox.test(dataN$var1, dataN$var2, paired=TRUE) #    
kruskal.test(list(dataN$var1, dataN$var2))       #    

#  p-value < 0.05,     .

###################################################################################
#  3.    
###################################################################################

par(mar=c(4, 2, 1.5, 0.2))  #      , 
plot(data$h0050, data$h001m, type="p", main=" ", xlab="  0-50 ", ylab="  0-100 ")

#       ?
# 1.  ,   [-1;1]

cor(data$h0050, data$h001m)
cor.test(data$h0050, data$h001m) #    -  0, data$h001m) # 0:   = 0

plot(5:15, c(7:17), main="", xlab="", ylab="")
cor(5:15, c(7:17))

plot(5:15, c(-7:-17), main="", xlab="", ylab="")
cor(5:15, c(-7:-17))

plot(5:15, c(7:15, 23, 20), main="", xlab="", ylab="")
cor(5:15, c(7:15, 23, 20))
cor(5:15, c(7:15, 23, 20), method="spearman") #     -  

plot(5:15, log(5:15), main="", xlab="", ylab="")
cor(5:15, log(5:15))
cor(5:15, log(5:15), method="spearman")

plot(data$h0050, data$h001m, type="p", main="", xlab="", ylab="")
cor(data$h0050, data$h001m)

str(data)
data[,12:21]                 #   :   - ,  - 
data[data$sid=="", 12:21]  #   :   - ,  - 
pairs(data[ ,12:21], pch=21) #  
cor(data[ ,12:21])           #   
symnum(cor(data[ ,12:21]))   #    

# heatmap -    
cor.l <- cor(data[ ,12:21])   
image(1:ncol(cor.l), 1:nrow(cor.l), cor.l, col=heat.colors(22), axes=FALSE, xlab="", ylab="")
axis(1, at=1:ncol(cor.l), labels=abbreviate(colnames(cor.l)))
axis(2, at=1:nrow(cor.l), labels=abbreviate(rownames(cor.l)), las = 2)

#       
#install.packages('ellipse', dep=TRUE) #     beeswarm
library(ellipse)
cor.l <- cor(data[ ,12:21])   #       
colnames(cor.l) <- abbreviate(colnames(cor.l))
rownames(cor.l) <- abbreviate(rownames(cor.l))
plotcorr(cor.l, type="lower", mar=c(0,0,0,0))

#      [NA]:
# use = "all.obs"               -          ( )
# use = "complete.obs"          -    ,      
# use = "pairwise.complete.obs" -       ( N !)
# cor(data[ ,8:17], use = "pairwise.complete.obs")

# 2.   y = b0 + b1*x,   R ?? [0;1]
#     lm():

lm.hum50100 <- lm(formula = data$h001m ~ data$h0050)
lm.hum50100   #   :

#   :
b0 <- lm.hum50100$coefficient[1]
b1 <- lm.hum50100$coefficient[2]
x1 <- min(data$h0050)
x2 <- max(data$h0050)
x <- seq(from = x1, to = x2, length.out =20)
y <- b0 + b1*x
plot(data$h0050, data$h001m, main="", xlab="", ylab="")
grid()
lines(x, y, type="l", col="red") #   

summary(lm.hum50100)

#   
plot(data$h001m, lm.hum50100$fitted.values, main="", xlab="", ylab="")
abline(0,1, lty=2, col="red")
library(ithir)
goof(observed = data$h001m, predicted = lm.hum50100$fitted.values)


